using System;
using System.Data.SqlClient;
using System.Linq;
using SvetoforVKBot.Models.Updates;
using VkNet;
using VkNet.Enums.SafetyEnums;
using VkNet.Model.Keyboard;
using VkNet.Model.RequestParams;

namespace SvetoforVKBot.Models.Commands
{
    public class SelectAskQuestionsCommand : Command
    {
        public override string Name => "{\"button\":\"selectAskQuestions\"}";

        public override void Execute(RootObject update, VkApi client, SvetoforVKBot.Data.SvetoforVKBotEntities db)
        {
        }

        public override void ExecutePL(RootObject update, VkApi client, SvetoforVKBot.Data.SvetoforVKBotEntities db)
        {
            MessagesSendParams @params = new MessagesSendParams();
            var chatId = update.@object.message.from_id;
            var keyboardBuilder = new KeyboardBuilder().Clear();

            try
            {
                var user = db.Users.Single(usr => usr.chatId == chatId);
                user.tag = "Вопрос";
                db.SaveChanges();

                keyboardBuilder
                    .AddButton("⬅Назад", "startPL", KeyboardButtonColor.Default)
                    .Build();

                @params.Keyboard = keyboardBuilder.Build();
                @params.UserId = chatId;
                @params.Message = "Запиши сюда свой вопрос одним сообщением. Я отправлю его специалисту.✌🏻";
                @params.RandomId = GetRandomId();
                client.Messages.SendAsync(@params);
            }
            catch (Exception ee)
            {
                @params.Message = "Ошибка в SelectAskQuestionsCommand: " + ee.Message;
                @params.Attachments = null;
                @params.Keyboard = null;
                @params.UserId = 59111081;
                @params.RandomId = GetRandomId();
                client.Messages.SendAsync(@params);
            }
        }
    }
}